## Coding standards

First, `go fmt` and `goimports` must be applied for all Go-sources.

Also we use [golangci-lint](https://golangci-lint.run/) analysis tool. See [.golangci.yml](./.golangci.yml) for enabled linters.

__New code MUST meet__ the linter requirements!

## Proto format

As you know there is a tool named `clang-format` which able to format proto-sources. We use it too to support generic formatting. It is a part of [LLVM project](https://llvm.org/). After installing the tool make appropriate settings to your IDE to use `clang-format` on saving the proto-files.


## External dependencies

- go compiler (>=1.10)
- protoc (>=3.9) && (<=3.13)

## Generating Go sources


### External go tools

You should install required executable tools before generating Go sources.

`go generate tools.go` should install all external go tools required for building a project. Alternatively `make bin-tools` may be used.

Note, if you installed tools for different project, your may need to reinstall it again here.

### API
`go generte api/api.go` should generate GRPC api using *.proto. Alternatively `make api` may be used.

### Implementation assets
`go generate` in project root should dispath `go generate` to all implementation packages listed in [generate.go](generate.go)

## building

- `go install ./cmd/...` should build all project executables

## Make

Run `make` under the project root without arguments to see provided actions that are automated already.
