package test

import (
	auth "gitlab.mashroom.com/mashroom/backend/auth/api"
)

func (s *serviceSuite) TestAuthRefresh_ok() {
	s.expectSessionIntrospect(s.expectRefreshToken(0), true)

	s.storage.EXPECT().SessionRefresh(s.testCtx, s.expectRefreshToken(0)).Return(s.expectSessionAuth(1), nil)

	resp, err := s.srv.Refresh(s.testCtx, &auth.RefreshRequest{
		AccessToken:  s.expectAccessToken(0),
		RefreshToken: s.expectRefreshToken(0),
		AdminSite:    false,
	})

	s.Require().NoError(err)

	s.Require().NotNil(resp)

	s.Require().Equal(s.expectAccessToken(1), resp.AccessToken)
	s.Require().Equal(s.expectRefreshToken(1), resp.RefreshToken)
}

func (s *serviceSuite) TestAuthRefresh_error() {
	s.storage.EXPECT().SessionIntrospect(s.testCtx, s.expectRefreshToken(0)).Return(nil, s.expectError())

	resp, err := s.srv.Refresh(s.testCtx, &auth.RefreshRequest{
		AccessToken:  s.expectAccessToken(0),
		RefreshToken: s.expectRefreshToken(0),
		AdminSite:    false,
	})

	s.Require().Error(err)

	s.Require().Nil(resp)
}
