package storage

import "gitlab.mashroom.com/mashroom/backend/auth/keycloak"

// SessionIntrospection represents token introspection reply
type SessionIntrospection struct {
	keycloak.OpenIDErrorRepresentation
	keycloak.OpenIDIntrospectionRepresentation
}

// SessionAuth represents authentication reply with access/refresh tokens
type SessionAuth struct {
	keycloak.OpenIDAuthRepresentation
	keycloak.OpenIDErrorRepresentation
}

// User represents one of realm users
type User keycloak.UserRepresentation

// Role represents one of realm roles
type Role keycloak.RoleRepresentation
