package keycloak

// OpenIDIntrospectionRepresentation is data model of access token introspection response.
type OpenIDIntrospectionRepresentation struct {
	Jti               string   `json:"jti"`
	Exp               int64    `json:"exp"`
	Nbf               int64    `json:"nbf"`
	Iat               int64    `json:"iat"`
	Iss               string   `json:"iss"`
	Sub               string   `json:"sub"`
	Typ               string   `json:"typ"`
	Azp               string   `json:"azp"`
	AuthTime          int64    `json:"auth_time"`
	SessionState      string   `json:"session_state"`
	PreferredUsername string   `json:"preferred_username"`
	Email             string   `json:"email"`
	EmailVerified     bool     `json:"email_verified"`
	PhoneNumber       string   `json:"phone_number"`
	PhoneVerified     bool     `json:"phone_verified"`
	Acr               string   `json:"acr"`
	AllowedOrigins    []string `json:"allowed_origins"`
	Scope             string   `json:"scope"`
	ClientID          string   `json:"client_id"`
	Username          string   `json:"username"`
	Active            bool     `json:"active"`
	RealmAccess       struct {
		Roles []string `json:"roles"`
	} `json:"realm_access"`
}
